leetcode面试题17.04:消失的数字(C语言版)

思路1

先排序,再依次查找,如果下一个值不等于前一个+1,那么下一个值就是消失数字。

时间复杂度分析:冒泡排序的时间复杂度为O(N^2),qsort排序时间复杂度为O(N*logN)。因此该思路不可行。


思路2

求和0到N,再减去数组中求和的值。

时间复杂度分析:两次循环,结果为O(N)。因此该思路可行,但有内存溢出风险。(这边可以通过等差数列求和公式求和,这样只需要一次循环,速度更快)


思路3

通过异或操作符号,相同的值为0,不相同的值为1;因为有 a^a = 0 已经 0^a = a 这两条性质,第一次遍历循环把数组全部的元素异或,第二次遍历循环再把numSize大小的元素异或,那么就可以找到只出现了一次的数字,即为消失的数字。(可以通过下图辅助理解)

时间复杂度:两次次循环,结果为O(N)。因此该思路可行,同时没有溢出风险,是最优解。

思路2的代码:

cpp 复制代码
int missingNumber(int* nums, int numsSize){
    int sum=0,i=0,cmp=0;
    for(i=0;i<numsSize;i++)
        sum+=nums[i];
    for(i=0;i<=numsSize;i++)
        cmp+=i;
    return cmp-sum;
}

思路3的代码:

cpp 复制代码
int missingNumber(int* nums, int numsSize){
    int N=numsSize;
    int x=0;
    for(int i=0;i<numsSize;i++)
    {
        x^=nums[i];
    }
    for(int j=0;j<=N;j++)
    {
        x^=j;
    }
    return x;
}
相关推荐
All for pursuit.13 小时前
【分治-3】347.前K个高频元素
数据结构·c++·算法·leetcode
All for pursuit.14 小时前
【二分查找-2】34.在排序数组中查找元素的第一个和最后一个位置
数据结构·c++·算法·leetcode
blxr_19 小时前
力扣hot100爬楼梯https://leetcode.cn/problems/climbing-stairs/
算法·leetcode·职场和发展
Navigator_Z20 小时前
LeetCode //C - 1275. Find Winner on a Tic Tac Toe Game
c语言·算法·leetcode
All for pursuit.1 天前
【分治-2】215.数组中的第K个最大元素
数据结构·c++·算法·leetcode
blxr_1 天前
力扣hot100前k个高频元素https://leetcode.cn/problems/top-k-frequent-elements/
算法·leetcode·职场和发展
longlongzihan1 天前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
smj2302_796826522 天前
解决leetcode第4064题至多一次取反能被k整除的最长子数组II
python·算法·leetcode
青山木2 天前
Hot 100 --- 下一个排列
java·数据结构·算法·leetcode
垆边人似月.2 天前
字符串重排后最大字典序
算法·leetcode·职场和发展